# Misc configuration properties

A reminder: any of these properties can be converted into yaml config properties, an example:

`KAFKA_CLUSTERS_0_BOOTSTRAPSERVERS`

becomes

```yaml
kafka:
  clusters:
    - bootstrapServers: xxx
```

| Name                                                           | Description                                                                                                                                                      |
| -------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `SERVER_SERVLET_CONTEXT_PATH`                                  | URI basePath                                                                                                                                                     |
| `LOGGING_LEVEL_ROOT`                                           | Setting log level (trace, debug, info, warn, error). Default: info                                                                                               |
| `LOGGING_LEVEL_IO_KAFBAT_UI`                                   | Setting log level (trace, debug, info, warn, error). Default: debug                                                                                              |
| `SERVER_PORT`                                                  | Port for the embedded server. Default: `8080`                                                                                                                    |
| `KAFKA_ADMIN-CLIENT-TIMEOUT`                                   | Kafka API timeout in ms. Default: `30000`                                                                                                                        |
| `KAFKA_CLUSTERS_0_NAME`                                        | Cluster name                                                                                                                                                     |
| `KAFKA_CLUSTERS_0_BOOTSTRAPSERVERS`                            | Address where to connect                                                                                                                                         |
| `KAFKA_CLUSTERS_0_KSQLDBSERVER`                                | KSQL DB server address                                                                                                                                           |
| `KAFKA_CLUSTERS_0_KSQLDBSERVERAUTH_USERNAME`                   | KSQL DB server's basic authentication username                                                                                                                   |
| `KAFKA_CLUSTERS_0_KSQLDBSERVERAUTH_PASSWORD`                   | KSQL DB server's basic authentication password                                                                                                                   |
| `KAFKA_CLUSTERS_0_KSQLDBSERVERSSL_KEYSTORELOCATION`            | Path to the JKS keystore to communicate to KSQL DB                                                                                                               |
| `KAFKA_CLUSTERS_0_KSQLDBSERVERSSL_KEYSTOREPASSWORD`            | Password of the JKS keystore for KSQL DB                                                                                                                         |
| `KAFKA_CLUSTERS_0_PROPERTIES_SECURITY_PROTOCOL`                | Security protocol to connect to the brokers. For SSL connection use "SSL", for plaintext connection don't set this environment variable                          |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRY`                              | SchemaRegistry's address                                                                                                                                         |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_USERNAME`                 | SchemaRegistry's basic authentication username                                                                                                                   |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_PASSWORD`                 | SchemaRegistry's basic authentication password                                                                                                                   |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_OAUTH_TOKENURL`           | Token URL for SchemaRegistry's OAuth client-credentials authentication. Cannot be combined with Basic auth on the same cluster.                                  |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_OAUTH_CLIENTID`           | Client ID for SchemaRegistry's OAuth authentication                                                                                                              |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_OAUTH_CLIENTSECRET`       | Client secret for SchemaRegistry's OAuth authentication                                                                                                          |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_OAUTH_SCOPES`             | Comma-separated list of OAuth scopes to request for SchemaRegistry authentication                                                                                |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_OAUTH_TOKENCACHEENABLED`  | Enable caching of OAuth tokens for SchemaRegistry. Default: `true`                                                                                               |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_OAUTH_TOKENREFRESHBUFFER` | Duration before token expiry to proactively refresh the token (e.g. `60s`, `360s`). Default: `60s`                                                               |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYAUTH_OAUTH_MAXRETRIES`         | Max number of retries on 401 Unauthorized responses from SchemaRegistry. Default: `1`                                                                            |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYSSL_KEYSTORELOCATION`          | Path to the JKS keystore to communicate to SchemaRegistry                                                                                                        |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYSSL_KEYSTOREPASSWORD`          | Password of the JKS keystore for SchemaRegistry                                                                                                                  |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYSHOWNULLVALUES`                | Show null fields in Avro messages instead of omitting them. Default: false                                                                                       |
| `KAFKA_CLUSTERS_0_SCHEMAREGISTRYUSEFULLYQUALIFIEDNAMES`        | Use fully qualified type names in Avro unions (e.g., `io.kafbat.Foo` instead of `Foo`). Default: false                                                           |
| `KAFKA_CLUSTERS_0_METRICS_SSL`                                 | Enable SSL for Metrics (for PROMETHEUS metrics type). Default: false.                                                                                            |
| `KAFKA_CLUSTERS_0_METRICS_USERNAME`                            | Username for Metrics authentication                                                                                                                              |
| `KAFKA_CLUSTERS_0_METRICS_PASSWORD`                            | Password for Metrics authentication                                                                                                                              |
| `KAFKA_CLUSTERS_0_METRICS_KEYSTORELOCATION`                    | Path to the JKS keystore to communicate to metrics source (JMX/PROMETHEUS). For advanced setup, see `kafbat-ui-jmx-secured.yml`                                  |
| `KAFKA_CLUSTERS_0_METRICS_KEYSTOREPASSWORD`                    | Password of the JKS metrics keystore                                                                                                                             |
| `KAFKA_CLUSTERS_0_SCHEMANAMETEMPLATE`                          | How keys are saved to schemaRegistry                                                                                                                             |
| `KAFKA_CLUSTERS_0_METRICS_PORT`                                | Open metrics port of a broker                                                                                                                                    |
| `KAFKA_CLUSTERS_0_METRICS_TYPE`                                | Type of metrics retriever to use. Valid values are JMX (default) or PROMETHEUS. If Prometheus, then metrics are read from prometheus-jmx-exporter instead of jmx |
| `KAFKA_CLUSTERS_0_READONLY`                                    | Enable read-only mode. Default: false                                                                                                                            |
| `KAFKA_CLUSTERS_0_KAFKACONNECT_0_NAME`                         | Given name for the Kafka Connect cluster                                                                                                                         |
| `KAFKA_CLUSTERS_0_KAFKACONNECT_0_ADDRESS`                      | Address of the Kafka Connect service endpoint                                                                                                                    |
| `KAFKA_CLUSTERS_0_KAFKACONNECT_0_USERNAME`                     | Kafka Connect cluster's basic authentication username                                                                                                            |
| `KAFKA_CLUSTERS_0_KAFKACONNECT_0_PASSWORD`                     | Kafka Connect cluster's basic authentication password                                                                                                            |
| `KAFKA_CLUSTERS_0_KAFKACONNECT_0_KEYSTORELOCATION`             | Path to the JKS keystore to communicate to Kafka Connect                                                                                                         |
| `KAFKA_CLUSTERS_0_KAFKACONNECT_0_KEYSTOREPASSWORD`             | Password of the JKS keystore for Kafka Connect                                                                                                                   |
| `KAFKA_CLUSTERS_0_SERDE_0_PROPERTIES_SHOWNULLVALUES`           | (SchemaRegistry) Show null fields in Avro messages. Default: false                                                                                               |
| `KAFKA_CLUSTERS_0_SERDE_0_PROPERTIES_USEFULLYQUALIFIEDNAMES`   | (SchemaRegistry) Use fully qualified type names in Avro unions. Default: false                                                                                   |
| `KAFKA_CLUSTERS_0_POLLING_THROTTLE_RATE`                       | Max traffic rate (bytes/sec) that kafbat-ui allowed to reach when polling messages from the cluster. Default: 0 (not limited)                                    |
| `KAFKA_CLUSTERS_0_SSL_TRUSTSTORELOCATION`                      | Path to the JKS truststore to communicate to Kafka Connect, SchemaRegistry, KSQL, Metrics                                                                        |
| `KAFKA_CLUSTERS_0_SSL_TRUSTSTOREPASSWORD`                      | Password of the JKS truststore for Kafka Connect, SchemaRegistry, KSQL, Metrics                                                                                  |
| `KAFKA_CLUSTERS_0_SSL_VERIFYSSL`                               | If set to false, SSL certificate of the host won't be verified. True by default.                                                                                 |
| `KAFKA_CONFIG_SANITIZER_ENABLED`                               | If set to false, disable configuration sanitizer (secret masking)                                                                                                |
| `TOPIC_RECREATE_DELAY_SECONDS`                                 | Time delay between topic deletion and topic creation attempts for topic recreate functionality. Default: 1                                                       |
| `TOPIC_RECREATE_MAXRETRIES`                                    | Number of attempts of topic creation after topic deletion for topic recreate functionality. Default: 15                                                          |
| `DYNAMIC_CONFIG_ENABLED`                                       | Allow to change application config in runtime. Default: false.                                                                                                   |
| kafka\_internalTopicPrefix                                     | Set a prefix for internal topics. Defaults to "\_".                                                                                                              |
| server.reactive.session.timeout                                | Session timeout. If a duration suffix is not specified, seconds will be used.                                                                                    |
| `GITHUB_RELEASE_INFO_ENABLED`                                  | Enable automatic check for the latest available release via GitHub API. Default: true                                                                            |
| `GITHUB_RELEASE_INFO_TIMEOUT`                                  | Request timeout for automatic release info checks in seconds. Default: 10                                                                                        |
| `GITHUB_RELEASE_UPDATE_RATE`                                   | Refresh rate (caching time) for release info from GitHub in milliseconds, ISO-8601 (e.g. "PT1H") or simple notation ("1h"). Default: 3600000                     |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://ui.docs.kafbat.io/configuration/misc-configuration-properties.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
